<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__ipc__pipe__functions" kind="group">
    <compoundname>group_ipc_pipe_functions</compoundname>
    <title>Functions</title>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__ipc__pipe__functions_1gad9865b8577da5a3d580bb6473f9b0912" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void Cy_IPC_Pipe_EndpointInit</definition>
        <argsstring>(uint32_t epAddr, cy_ipc_pipe_callback_array_ptr_t cbArray, uint32_t cbCnt, uint32_t epConfig, cy_stc_sysint_t const *epInterrupt)</argsstring>
        <name>Cy_IPC_Pipe_EndpointInit</name>
        <param>
          <type>uint32_t</type>
          <declname>epAddr</declname>
        </param>
        <param>
          <type>cy_ipc_pipe_callback_array_ptr_t</type>
          <declname>cbArray</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>cbCnt</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>epConfig</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structcy__stc__sysint__t">cy_stc_sysint_t</ref> const *</type>
          <declname>epInterrupt</declname>
        </param>
        <briefdescription>
<para>This function initializes the endpoint of a pipe for the current CPU. </para>        </briefdescription>
        <detaileddescription>
<para>The current CPU is the CPU that is executing the code. An endpoint of a pipe is for the IPC channel that receives a message for the current CPU.</para><para>After this function is called, the callbackArray needs to be populated with the callback functions for that endpoint using the <ref kindref="member" refid="group__group__ipc__pipe__functions_1ga2c998e0f6927eb99ac850daa4a2d5acc">Cy_IPC_Pipe_RegisterCallback()</ref> function.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;In general case, this function is called within &lt;a href="group__group__ipc__pipe__functions.html#group__group__ipc__pipe__functions_1gafb7fa479327e6d7c282c262bc1dc6c8c"&gt;Cy_IPC_Pipe_Init&lt;/a&gt;, so user doesn't need to call it anywhere. However, it may be useful in case of some pipe/endpoint customizations.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>epAddr</parametername>
</parameternamelist>
<parameterdescription>
<para>This parameter is the address (or index in the array of endpoint structures) that designates the endpoint you want to initialize.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>cbArray</parametername>
</parameternamelist>
<parameterdescription>
<para>This is a pointer to the callback function array. Based on the client ID, one of the functions in this array is called to process the message.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>cbCnt</parametername>
</parameternamelist>
<parameterdescription>
<para>This is the size of the callback array, or the number of defined clients.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>epConfig</parametername>
</parameternamelist>
<parameterdescription>
<para>This value defines the IPC channel, IPC interrupt number, and the interrupt mask for the entire pipe. The format of the endpoint configuration Bits[31:16] Interrupt Mask Bits[15:8 ] IPC interrupt Bits[ 7:0 ] IPC channel</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>epInterrupt</parametername>
</parameternamelist>
<parameterdescription>
<para>This is a pointer to the endpoint interrupt description structure.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="preprocessor">#define<sp />MY_IPC_PIPE_CLIENT_CNT<sp /><sp /><sp />(4UL)<sp /></highlight><highlight class="comment">/*<sp />Number<sp />of<sp />clients<sp />on<sp />each<sp />endpoint<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal">cy_ipc_pipe_callback_ptr_t<sp />myIpcPipeCbArray[MY_IPC_PIPE_CLIENT_CNT];</highlight></codeline>
</programlisting><programlisting><codeline><highlight class="preprocessor">#define<sp />MY_IPC_PIPE_CHAN_EP0<sp /><sp /><sp /><sp /><sp />(8UL)<sp /></highlight><highlight class="comment">/*<sp />IPC<sp />data<sp />channel<sp />for<sp />MYPIPE<sp />EP0<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MY_IPC_PIPE_CHAN_EP1<sp /><sp /><sp /><sp /><sp />(9UL)<sp /></highlight><highlight class="comment">/*<sp />IPC<sp />data<sp />channel<sp />for<sp />MYPIPE<sp />EP1<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MY_IPC_PIPE_INTR_EP0<sp /><sp /><sp /><sp /><sp />(8UL)<sp /></highlight><highlight class="comment">/*<sp />Notifier<sp />EP0<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MY_IPC_PIPE_INTR_EP1<sp /><sp /><sp /><sp /><sp />(9UL)<sp /></highlight><highlight class="comment">/*<sp />Notifier<sp />EP1<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MY_IPC_PIPE_INTR_MUX_EP0<sp />(1UL)<sp /></highlight><highlight class="comment">/*<sp />CM0+<sp />NVIC<sp />MUX<sp />for<sp />IPC<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MY_IPC_PIPE_INTR_MASK<sp /><sp /><sp /><sp />(uint32_t)((1UL<sp />&lt;&lt;<sp />MY_IPC_PIPE_CHAN_EP0)<sp />|\</highlight></codeline>
<codeline><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(1UL<sp />&lt;&lt;<sp />MY_IPC_PIPE_CHAN_EP1))</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MY_IPC_PIPE_EP0_CONFIG<sp /><sp /><sp />(_VAL2FLD(CY_IPC_PIPE_CFG_IMASK,<sp />MY_IPC_PIPE_INTR_MASK)<sp />|\</highlight></codeline>
<codeline><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_VAL2FLD(CY_IPC_PIPE_CFG_INTR,<sp /><sp />MY_IPC_PIPE_INTR_EP0)<sp />|\</highlight></codeline>
<codeline><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_VAL2FLD(CY_IPC_PIPE_CFG_CHAN,<sp /><sp />MY_IPC_PIPE_CHAN_EP0))</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MY_IPC_PIPE_EP1_CONFIG<sp /><sp /><sp />(_VAL2FLD(CY_IPC_PIPE_CFG_IMASK,<sp />MY_IPC_PIPE_INTR_MASK)<sp />|\</highlight></codeline>
<codeline><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_VAL2FLD(CY_IPC_PIPE_CFG_INTR,<sp /><sp />MY_IPC_PIPE_INTR_EP1)<sp />|\</highlight></codeline>
<codeline><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_VAL2FLD(CY_IPC_PIPE_CFG_CHAN,<sp /><sp />MY_IPC_PIPE_CHAN_EP1))</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="compound" refid="structcy__stc__ipc__pipe__ep__config__t">cy_stc_ipc_pipe_ep_config_t</ref><sp />myIpcPipeEp0Config<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />MY_IPC_PIPE_INTR_EP0,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ipcNotifierNumber<sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />1UL,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ipcNotifierPriority<sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />MY_IPC_PIPE_INTR_MUX_EP0,<sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ipcNotifierMuxNumber<sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />MY_IPC_PIPE_EP_ADDR_CM0,<sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.epAddress<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />MY_IPC_PIPE_EP0_CONFIG<sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.epConfig<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="compound" refid="structcy__stc__ipc__pipe__ep__config__t">cy_stc_ipc_pipe_ep_config_t</ref><sp />myIpcPipeEp1Config<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />MY_IPC_PIPE_INTR_EP1,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ipcNotifierNumber<sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />1UL,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ipcNotifierPriority<sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />0UL,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ipcNotifierMuxNumber<sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />MY_IPC_PIPE_EP_ADDR_CM4,<sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.epAddress<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />MY_IPC_PIPE_EP1_CONFIG<sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.epConfig<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
</programlisting><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />it<sp />may<sp />be<sp />usable<sp />in<sp />case<sp />if<sp />user<sp />wants<sp />to<sp />setup<sp />theirs<sp />own</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />custom<sp />pipe.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />Instead,<sp />in<sp />general<sp />cases<sp />user<sp />can<sp />just<sp />register<sp />custom<sp />client<sp />IDs</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />(callbacks)<sp />into<sp />the<sp />System<sp />Pipe<sp />(CYPIPE)<sp />using<sp />Cy_IPC_Pipe_RegisterCallback</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__ipc__pipe__ep__config__t">cy_stc_ipc_pipe_ep_config_t</ref><sp />*<sp />epReceiverConfig;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__ipc__pipe__ep__config__t">cy_stc_ipc_pipe_ep_config_t</ref><sp />*<sp />epSenderConfig;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__sysint__t">cy_stc_sysint_t</ref><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />epIntrConfig;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#if<sp />(CY_CPU_CORTEX_M0P)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />epReceiverConfig<sp /><sp /><sp /><sp /><sp />=<sp />&amp;myIpcPipeEp0Config;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />epSenderConfig<sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />&amp;myIpcPipeEp1Config;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />epIntrConfig.<ref kindref="member" refid="structcy__stc__sysint__t_1a6da08d81da65a7f93d3e4c46a4b8d950">intrSrc</ref><sp />=<sp />(<ref kindref="member" refid="group__group__sysint__enums_1ga7e1129cd8a196f4284d41db3e82ad5c8">IRQn_Type</ref>)epReceiverConfig-&gt;<ref kindref="member" refid="structcy__stc__ipc__pipe__ep__config__t_1a42676bbce63ebf43f3aa42791473b6e0">ipcNotifierMuxNumber</ref>;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />#</highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />epReceiverConfig<sp /><sp /><sp /><sp /><sp />=<sp />&amp;myIpcPipeEp1Config;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />epSenderConfig<sp /><sp /><sp /><sp /><sp /><sp /><sp />=<sp />&amp;myIpcPipeEp0Config;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />epIntrConfig.<ref kindref="member" refid="structcy__stc__sysint__t_1a6da08d81da65a7f93d3e4c46a4b8d950">intrSrc</ref><sp />=<sp />(<ref kindref="member" refid="group__group__sysint__enums_1ga7e1129cd8a196f4284d41db3e82ad5c8">IRQn_Type</ref>)(cy_device-&gt;cpussIpc0Irq<sp />+<sp />epReceiverConfig-&gt;<ref kindref="member" refid="structcy__stc__ipc__pipe__ep__config__t_1a85b43b574d346e8711b0737fc317fa44">ipcNotifierNumber</ref>);</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#endif</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />epIntrConfig.<ref kindref="member" refid="structcy__stc__sysint__t_1a97b1a2acb12257a8b213a5e971ceae3d">intrPriority</ref><sp /><sp /><sp /><sp /><sp />=<sp />epReceiverConfig-&gt;<ref kindref="member" refid="structcy__stc__ipc__pipe__ep__config__t_1a6c4e6bb126976ea855403085c664c973">ipcNotifierPriority</ref>;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />the<sp />Receiver<sp />endpoint<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ipc__pipe__functions_1gad9865b8577da5a3d580bb6473f9b0912">Cy_IPC_Pipe_EndpointInit</ref>(epReceiverConfig-&gt;<ref kindref="member" refid="structcy__stc__ipc__pipe__ep__config__t_1a786ab9fcb46901b27cdb02942546fc2b">epAddress</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />myIpcPipeCbArray,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />MY_IPC_PIPE_CLIENT_CNT,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />epReceiverConfig-&gt;<ref kindref="member" refid="structcy__stc__ipc__pipe__ep__config__t_1ab02225e6a333e91063e0a37a4f93a14c">epConfig</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />&amp;epIntrConfig);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Create<sp />the<sp />Sender<sp />endpoint<sp />just<sp />for<sp />reference<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ipc__pipe__functions_1gad9865b8577da5a3d580bb6473f9b0912">Cy_IPC_Pipe_EndpointInit</ref>(epSenderConfig-&gt;<ref kindref="member" refid="structcy__stc__ipc__pipe__ep__config__t_1a786ab9fcb46901b27cdb02942546fc2b">epAddress</ref>,<sp />NULL,<sp />0UL,<sp />epSenderConfig-&gt;<ref kindref="member" refid="structcy__stc__ipc__pipe__ep__config__t_1ab02225e6a333e91063e0a37a4f93a14c">epConfig</ref>,<sp />NULL);</highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="218" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_pipe.c" bodystart="186" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_ipc_pipe.h" line="266" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__ipc__pipe__functions_1ga2a3f9b25f2227abe8cf66880c1d5d5a5" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__ipc__pipe__enums_1ga91750337b3471d3eb01ec316358d0598">cy_en_ipc_pipe_status_t</ref></type>
        <definition>cy_en_ipc_pipe_status_t Cy_IPC_Pipe_SendMessage</definition>
        <argsstring>(uint32_t toAddr, uint32_t fromAddr, void *msgPtr, cy_ipc_pipe_relcallback_ptr_t callBackPtr)</argsstring>
        <name>Cy_IPC_Pipe_SendMessage</name>
        <param>
          <type>uint32_t</type>
          <declname>toAddr</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>fromAddr</declname>
        </param>
        <param>
          <type>void *</type>
          <declname>msgPtr</declname>
        </param>
        <param>
          <type>cy_ipc_pipe_relcallback_ptr_t</type>
          <declname>callBackPtr</declname>
        </param>
        <briefdescription>
<para>This function is used to send a message from one endpoint to another. </para>        </briefdescription>
        <detaileddescription>
<para>It generates an interrupt on the endpoint that receives the message and a release interrupt to the sender to acknowledge the message has been processed.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>toAddr</parametername>
</parameternamelist>
<parameterdescription>
<para>This parameter is the address (or index in the array of endpoint structures) of the endpoint to which you are sending the message.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>fromAddr</parametername>
</parameternamelist>
<parameterdescription>
<para>This parameter is the address (or index in the array of endpoint structures) of the endpoint from which the message is being sent.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>msgPtr</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to the message structure to be sent.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>callBackPtr</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to the Release callback function.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_IPC_PIPE_SUCCESS: Message was sent to the other end of the pipe CY_IPC_PIPE_ERROR_BAD_HANDLE: The handle provided for the pipe was not valid CY_IPC_PIPE_ERROR_SEND_BUSY: The pipe is already busy sending a message</para></simplesect>
<simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />myReleaseCallback(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />sent<sp />data<sp />is<sp />already<sp />processed<sp />on<sp />the<sp />receiver<sp />side,</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />the<sp />pipe<sp />is<sp />ready<sp />for<sp />next<sp />transactions</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />there<sp />is<sp />a<sp />need<sp />to<sp />send<sp />a<sp />message<sp />to<sp />the<sp />MY_IPC_CLIENT_ID<sp />client</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />on<sp />another<sp />CPU<sp />side<sp />with<sp />the<sp />user<sp />code<sp />MY_IPC_MSG_USR_CODE</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />MY_IPC_CLIENT_ID<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(4UL)<sp /></highlight><highlight class="comment">/*<sp />Example<sp />client<sp />ID<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />MY_IPC_MSG_USR_CODE<sp /><sp /><sp /><sp /><sp />(5UL)<sp /></highlight><highlight class="comment">/*<sp />Example<sp />message<sp />user<sp />code<sp />for<sp />client<sp />#MY_IPC_CLIENT_ID<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />MY_IPC_MSG_SIZE<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(7UL)<sp /></highlight><highlight class="comment">/*<sp />Example<sp />message<sp />size<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />myMsg[MY_IPC_MSG_SIZE];<sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Example<sp />message<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />myMsg[0]<sp />=<sp />_VAL2FLD(CY_IPC_PIPE_MSG_CLIENT,<sp /><sp />MY_IPC_CLIENT_ID)<sp />|</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_VAL2FLD(CY_IPC_PIPE_MSG_USR,<sp /><sp /><sp /><sp /><sp />MY_IPC_MSG_USR_CODE)<sp />|</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_VAL2FLD(CY_IPC_PIPE_MSG_RELEASE,<sp />CY_SYS_CYPIPE_INTR_MASK<sp />);<sp /></highlight><highlight class="comment">/*<sp />Example<sp />message<sp />header<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />CY_SYS_CYPIPE_INTR_MASK<sp />is<sp />combined<sp />masks<sp />of<sp />both<sp />pipe<sp />endpoints</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />interrupt<sp />channels<sp />-<sp />to<sp />notify<sp />both<sp />sides<sp />about<sp />an<sp />event,<sp />as<sp />example.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />The<sp />rest<sp />of<sp />the<sp />message<sp />content<sp />(as<sp />well<sp />as<sp />message<sp />size<sp />and<sp />user<sp />codes</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />in<sp />the<sp />first<sp />message's<sp />word)<sp />can<sp />be<sp />defined<sp />by<sp />user<sp />without<sp />any<sp />restrictions.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ipc__pipe__functions_1ga2a3f9b25f2227abe8cf66880c1d5d5a5">Cy_IPC_Pipe_SendMessage</ref>(CY_IPC_EP_CYPIPE_TO_ADDR,<sp />CY_IPC_EP_CYPIPE_FROM_ADDR,<sp />(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*)<sp />&amp;myMsg,<sp />myReleaseCallback);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />myReleaseCallback<sp />will<sp />be<sp />called<sp />when<sp />addressee<sp />has<sp />handled<sp />the<sp />message,</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />i.e.<sp />the<sp />correspondent<sp />notify<sp />callback<sp />is<sp />returned.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="323" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_pipe.c" bodystart="253" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_ipc_pipe.h" line="268" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__ipc__pipe__functions_1ga2c998e0f6927eb99ac850daa4a2d5acc" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__ipc__pipe__enums_1ga91750337b3471d3eb01ec316358d0598">cy_en_ipc_pipe_status_t</ref></type>
        <definition>cy_en_ipc_pipe_status_t Cy_IPC_Pipe_RegisterCallback</definition>
        <argsstring>(uint32_t epAddr, cy_ipc_pipe_callback_ptr_t callBackPtr, uint32_t clientId)</argsstring>
        <name>Cy_IPC_Pipe_RegisterCallback</name>
        <param>
          <type>uint32_t</type>
          <declname>epAddr</declname>
        </param>
        <param>
          <type>cy_ipc_pipe_callback_ptr_t</type>
          <declname>callBackPtr</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>clientId</declname>
        </param>
        <briefdescription>
<para>This function registers a callback that is called when a message is received on a pipe. </para>        </briefdescription>
        <detaileddescription>
<para>The client_ID is the same as the index of the callback function array. The callback may be a real function pointer or NULL if no callback is required.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>epAddr</parametername>
</parameternamelist>
<parameterdescription>
<para>This parameter is the address (or index in the array of endpoint structures) that designates the endpoint to which you want to add callback functions.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>callBackPtr</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to the callback function called when the endpoint has received a message. If this parameters is NULL current callback will be unregistered.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>clientId</parametername>
</parameternamelist>
<parameterdescription>
<para>The index in the callback array (Client ID) where the function pointer is saved.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_IPC_PIPE_SUCCESS: Callback registered successfully CY_IPC_PIPE_ERROR_BAD_CLIENT: Client ID out of range, callback not registered.</para></simplesect>
<simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="preprocessor">#define<sp />MY_IPC_MSG_SIZE<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(7UL)<sp /></highlight><highlight class="comment">/*<sp />Example<sp />message<sp />size<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal">uint32_t<sp />myMsg[MY_IPC_MSG_SIZE];<sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Example<sp />message<sp />container<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />myAcquireCallback(uint32_t<sp />*<sp />msgData)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />i;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal">(i<sp />=<sp />0;<sp />i<sp />&lt;<sp />MY_IPC_MSG_SIZE;<sp />i++)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />myMsg[i]<sp />=<sp />*((uint32_t*)((uint32_t)msgData<sp />+<sp />i));<sp /></highlight><highlight class="comment">/*<sp />Copying<sp />the<sp />message<sp />content<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />release<sp />callback<sp />will<sp />be<sp />automatically<sp />called<sp />on<sp />the<sp />sender<sp />side</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />just<sp />after<sp />returning<sp />from<sp />this<sp />callback</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />there<sp />is<sp />a<sp />need<sp />to<sp />register<sp />an<sp />acquire<sp />notify<sp />event<sp />callback<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />MY_IPC_CLIENT_ID<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(4UL)<sp /></highlight><highlight class="comment">/*<sp />Example<sp />client<sp />ID<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__ipc__pipe__enums_1gga91750337b3471d3eb01ec316358d0598a81f0db1ecbe617526b177482b818d3c2">CY_IPC_PIPE_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__ipc__pipe__functions_1ga2c998e0f6927eb99ac850daa4a2d5acc">Cy_IPC_Pipe_RegisterCallback</ref>(CY_IPC_EP_CYPIPE_ADDR,<sp />myAcquireCallback,<sp />MY_IPC_CLIENT_ID))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Handle<sp />possible<sp />errors<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="379" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_pipe.c" bodystart="355" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_ipc_pipe.h" line="270" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__ipc__pipe__functions_1ga7cff3c4286e6e23519d9925d394ac218" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void Cy_IPC_Pipe_ExecuteCallback</definition>
        <argsstring>(uint32_t epAddr)</argsstring>
        <name>Cy_IPC_Pipe_ExecuteCallback</name>
        <param>
          <type>uint32_t</type>
          <declname>epAddr</declname>
        </param>
        <briefdescription>
<para>This function is called by the ISR for a given pipe endpoint to dispatch the appropriate callback function based on the client ID for that endpoint. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>epAddr</parametername>
</parameternamelist>
<parameterdescription>
<para>This parameter is the address (or index in the array of endpoint structures) that designates the endpoint to process.</para></parameterdescription>
</parameteritem>
</parameterlist>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;This function should be used instead of obsolete &lt;a href="group__group__ipc__pipe__functions.html#group__group__ipc__pipe__functions_1ga57550447f7bca5f2990868bac69f41dc"&gt;Cy_IPC_Pipe_ExecCallback()&lt;/a&gt; function because it will be removed in the next releases.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="comment">/*<sp />Number<sp />of<sp />endpoints<sp />of<sp />the<sp />MyPipe<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MY_IPC_PIPE_MAX_ENDPOINTS<sp /><sp /><sp /><sp /><sp />(2UL)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Endpoint<sp />indexes<sp />in<sp />the<sp />pipe<sp />array<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MY_IPC_PIPE_EP_ADDR_CM0<sp /><sp /><sp /><sp /><sp /><sp /><sp />(0UL)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MY_IPC_PIPE_EP_ADDR_CM4<sp /><sp /><sp /><sp /><sp /><sp /><sp />(1UL)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="compound" refid="structcy__stc__ipc__pipe__ep__t">cy_stc_ipc_pipe_ep_t</ref><sp />myIpcPipeEpArray[MY_IPC_PIPE_MAX_ENDPOINTS];</highlight></codeline>
</programlisting><programlisting><codeline><highlight class="comment">/*<sp />Scenario:<sp />the<sp />Cy_IPC_Pipe_ExecuteCallback<sp />is<sp />intended<sp />to<sp />use<sp />in<sp />the<sp />endpoint</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />notifier<sp />interrupt<sp />handler.</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />It<sp />may<sp />be<sp />usable<sp />in<sp />case<sp />if<sp />user<sp />wants<sp />to<sp />setup<sp />their<sp />own<sp />custom<sp />pipe.</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />In<sp />general<sp />cases<sp />user<sp />can<sp />just<sp />register<sp />custom<sp />client<sp />IDs<sp />(callbacks)</highlight></codeline>
<codeline><highlight class="comment"><sp />*<sp />into<sp />the<sp />System<sp />Pipe<sp />(CYPIPE)<sp />using<sp />\ref<sp />Cy_IPC_Pipe_RegisterCallback.</highlight></codeline>
<codeline><highlight class="comment"><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#if<sp />(CY_CPU_CORTEX_M0P)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />MY_IPC_PIPE_EP_ADDR<sp /><sp /><sp /><sp /><sp /><sp /><sp />MY_IPC_PIPE_EP_ADDR_CM0</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />MY_IPC_PIPE_EP_ADDR<sp /><sp /><sp /><sp /><sp /><sp /><sp />MY_IPC_PIPE_EP_ADDR_CM4</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#endif<sp /><sp /></highlight><highlight class="comment">/*<sp />(CY_CPU_CORTEX_M0P)<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />My_IPC_PipeIsr(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ipc__pipe__functions_1ga7cff3c4286e6e23519d9925d394ac218">Cy_IPC_Pipe_ExecuteCallback</ref>(MY_IPC_PIPE_EP_ADDR);</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="448" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_pipe.c" bodystart="439" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_ipc_pipe.h" line="272" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__ipc__pipe__functions_1gadd8badd20f9ca44b9abc51462f734c72" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void Cy_IPC_Pipe_RegisterCallbackRel</definition>
        <argsstring>(uint32_t epAddr, cy_ipc_pipe_relcallback_ptr_t callBackPtr)</argsstring>
        <name>Cy_IPC_Pipe_RegisterCallbackRel</name>
        <param>
          <type>uint32_t</type>
          <declname>epAddr</declname>
        </param>
        <param>
          <type>cy_ipc_pipe_relcallback_ptr_t</type>
          <declname>callBackPtr</declname>
        </param>
        <briefdescription>
<para>This function registers a default callback if a release interrupt is generated but the current release callback function is null. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>epAddr</parametername>
</parameternamelist>
<parameterdescription>
<para>This parameter is the address (or index in the array of endpoint structures) that designates the endpoint to which you want to add a release callback function.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>callBackPtr</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to the callback executed when the endpoint has received a message. If this parameters is NULL current callback will be unregistered.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>None</para></simplesect>
<simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />myDefaultReleaseCallback(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />Cy_IPC_Pipe_SendMessage<sp />was<sp />called<sp />without<sp />a<sp />pointer<sp />to<sp />specific<sp />callback,</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />threfore<sp />this<sp />one<sp />is<sp />called.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />The<sp />sent<sp />data<sp />is<sp />already<sp />processed<sp />on<sp />the<sp />receiver<sp />side,</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />the<sp />pipe<sp />is<sp />ready<sp />for<sp />next<sp />transactions</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />there<sp />is<sp />a<sp />need<sp />to<sp />register<sp />a<sp />default<sp />release<sp />callback<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ipc__pipe__functions_1gadd8badd20f9ca44b9abc51462f734c72">Cy_IPC_Pipe_RegisterCallbackRel</ref>(CY_IPC_EP_CYPIPE_ADDR,<sp />&amp;myDefaultReleaseCallback);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />myMsg;<sp /></highlight><highlight class="comment">/*<sp />Some<sp />already<sp />initialised<sp />message<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ipc__pipe__functions_1ga2a3f9b25f2227abe8cf66880c1d5d5a5">Cy_IPC_Pipe_SendMessage</ref>(CY_IPC_EP_CYPIPE_TO_ADDR,<sp />CY_IPC_EP_CYPIPE_FROM_ADDR,<sp />(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*)<sp />&amp;myMsg,<sp />NULL);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Therefore<sp />the<sp />myDefaultReleaseCallback<sp />will<sp />be<sp />called</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />when<sp />addressee<sp />has<sp />handled<sp />the<sp />message,</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />i.e.<sp />the<sp />correspondent<sp />acquire<sp />callback<sp />has<sp />returned.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="416" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_pipe.c" bodystart="406" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_ipc_pipe.h" line="273" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__ipc__pipe__functions_1ga7a1c8f1e92e74f27856ef2b7ac09c640" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void Cy_IPC_Pipe_Config</definition>
        <argsstring>(cy_stc_ipc_pipe_ep_t *theEpArray)</argsstring>
        <name>Cy_IPC_Pipe_Config</name>
        <param>
          <type><ref kindref="compound" refid="structcy__stc__ipc__pipe__ep__t">cy_stc_ipc_pipe_ep_t</ref> *</type>
          <declname>theEpArray</declname>
        </param>
        <briefdescription>
<para>This function stores a copy of a pointer to the array of endpoints. </para>        </briefdescription>
        <detaileddescription>
<para>All access to endpoints will be via the index of the endpoint in this array.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;In general case, this function is called in the default startup code, so user doesn't need to call it anywhere. However, it may be useful in case of some pipe customizations.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>theEpArray</parametername>
</parameternamelist>
<parameterdescription>
<para>This is the pointer to an array of endpoint structures that the designer created and will be used to reference all endpoints.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="comment">/*<sp />Number<sp />of<sp />endpoints<sp />of<sp />the<sp />MyPipe<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MY_IPC_PIPE_MAX_ENDPOINTS<sp /><sp /><sp /><sp /><sp />(2UL)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="comment">/*<sp />Endpoint<sp />indexes<sp />in<sp />the<sp />pipe<sp />array<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MY_IPC_PIPE_EP_ADDR_CM0<sp /><sp /><sp /><sp /><sp /><sp /><sp />(0UL)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MY_IPC_PIPE_EP_ADDR_CM4<sp /><sp /><sp /><sp /><sp /><sp /><sp />(1UL)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="compound" refid="structcy__stc__ipc__pipe__ep__t">cy_stc_ipc_pipe_ep_t</ref><sp />myIpcPipeEpArray[MY_IPC_PIPE_MAX_ENDPOINTS];</highlight></codeline>
</programlisting><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />there<sp />is<sp />a<sp />need<sp />to<sp />register<sp />the<sp />endpoint<sp />array<sp />prior<sp />to</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />pipe/endpoints<sp />initializing.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />It<sp />may<sp />be<sp />usable<sp />in<sp />case<sp />if<sp />user<sp />wants<sp />to<sp />setup<sp />theirs<sp />own<sp />custom<sp />pipe.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />Instead,<sp />in<sp />general<sp />cases<sp />user<sp />can<sp />just<sp />register<sp />custom<sp />client<sp />IDs</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />(callbacks)<sp />into<sp />the<sp />System<sp />Pipe<sp />(CYPIPE)<sp />using<sp />Cy_IPC_Pipe_RegisterCallback</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ipc__pipe__functions_1ga7a1c8f1e92e74f27856ef2b7ac09c640">Cy_IPC_Pipe_Config</ref>(myIpcPipeEpArray);</highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="59" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_pipe.c" bodystart="52" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_ipc_pipe.h" line="274" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__ipc__pipe__functions_1gafb7fa479327e6d7c282c262bc1dc6c8c" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void Cy_IPC_Pipe_Init</definition>
        <argsstring>(cy_stc_ipc_pipe_config_t const *config)</argsstring>
        <name>Cy_IPC_Pipe_Init</name>
        <param>
          <type><ref kindref="compound" refid="structcy__stc__ipc__pipe__config__t">cy_stc_ipc_pipe_config_t</ref> const *</type>
          <declname>config</declname>
        </param>
        <briefdescription>
<para>Initializes the system pipes. </para>        </briefdescription>
        <detaileddescription>
<para>The system pipes are used by BLE. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The function should be called on all CPUs.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;In general case, this function is called in the default startup code, so user doesn't need to call it anywhere. However, it may be useful in case of some pipe customizations.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>config</parametername>
</parameternamelist>
<parameterdescription>
<para>This is the pointer to the pipe configuration structure</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="preprocessor">#define<sp />MY_IPC_PIPE_CLIENT_CNT<sp /><sp /><sp />(4UL)<sp /></highlight><highlight class="comment">/*<sp />Number<sp />of<sp />clients<sp />on<sp />each<sp />endpoint<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal">cy_ipc_pipe_callback_ptr_t<sp />myIpcPipeCbArray[MY_IPC_PIPE_CLIENT_CNT];</highlight></codeline>
</programlisting><programlisting><codeline><highlight class="preprocessor">#define<sp />MY_IPC_PIPE_CHAN_EP0<sp /><sp /><sp /><sp /><sp />(8UL)<sp /></highlight><highlight class="comment">/*<sp />IPC<sp />data<sp />channel<sp />for<sp />MYPIPE<sp />EP0<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MY_IPC_PIPE_CHAN_EP1<sp /><sp /><sp /><sp /><sp />(9UL)<sp /></highlight><highlight class="comment">/*<sp />IPC<sp />data<sp />channel<sp />for<sp />MYPIPE<sp />EP1<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MY_IPC_PIPE_INTR_EP0<sp /><sp /><sp /><sp /><sp />(8UL)<sp /></highlight><highlight class="comment">/*<sp />Notifier<sp />EP0<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MY_IPC_PIPE_INTR_EP1<sp /><sp /><sp /><sp /><sp />(9UL)<sp /></highlight><highlight class="comment">/*<sp />Notifier<sp />EP1<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MY_IPC_PIPE_INTR_MUX_EP0<sp />(1UL)<sp /></highlight><highlight class="comment">/*<sp />CM0+<sp />NVIC<sp />MUX<sp />for<sp />IPC<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MY_IPC_PIPE_INTR_MASK<sp /><sp /><sp /><sp />(uint32_t)((1UL<sp />&lt;&lt;<sp />MY_IPC_PIPE_CHAN_EP0)<sp />|\</highlight></codeline>
<codeline><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(1UL<sp />&lt;&lt;<sp />MY_IPC_PIPE_CHAN_EP1))</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MY_IPC_PIPE_EP0_CONFIG<sp /><sp /><sp />(_VAL2FLD(CY_IPC_PIPE_CFG_IMASK,<sp />MY_IPC_PIPE_INTR_MASK)<sp />|\</highlight></codeline>
<codeline><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_VAL2FLD(CY_IPC_PIPE_CFG_INTR,<sp /><sp />MY_IPC_PIPE_INTR_EP0)<sp />|\</highlight></codeline>
<codeline><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_VAL2FLD(CY_IPC_PIPE_CFG_CHAN,<sp /><sp />MY_IPC_PIPE_CHAN_EP0))</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />MY_IPC_PIPE_EP1_CONFIG<sp /><sp /><sp />(_VAL2FLD(CY_IPC_PIPE_CFG_IMASK,<sp />MY_IPC_PIPE_INTR_MASK)<sp />|\</highlight></codeline>
<codeline><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_VAL2FLD(CY_IPC_PIPE_CFG_INTR,<sp /><sp />MY_IPC_PIPE_INTR_EP1)<sp />|\</highlight></codeline>
<codeline><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_VAL2FLD(CY_IPC_PIPE_CFG_CHAN,<sp /><sp />MY_IPC_PIPE_CHAN_EP1))</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="compound" refid="structcy__stc__ipc__pipe__ep__config__t">cy_stc_ipc_pipe_ep_config_t</ref><sp />myIpcPipeEp0Config<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />MY_IPC_PIPE_INTR_EP0,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ipcNotifierNumber<sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />1UL,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ipcNotifierPriority<sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />MY_IPC_PIPE_INTR_MUX_EP0,<sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ipcNotifierMuxNumber<sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />MY_IPC_PIPE_EP_ADDR_CM0,<sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.epAddress<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />MY_IPC_PIPE_EP0_CONFIG<sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.epConfig<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><ref kindref="compound" refid="structcy__stc__ipc__pipe__ep__config__t">cy_stc_ipc_pipe_ep_config_t</ref><sp />myIpcPipeEp1Config<sp />=</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />MY_IPC_PIPE_INTR_EP1,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ipcNotifierNumber<sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />1UL,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ipcNotifierPriority<sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />0UL,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ipcNotifierMuxNumber<sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />MY_IPC_PIPE_EP_ADDR_CM4,<sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.epAddress<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />MY_IPC_PIPE_EP1_CONFIG<sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.epConfig<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal">};</highlight></codeline>
</programlisting><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />it<sp />may<sp />be<sp />usable<sp />in<sp />case<sp />if<sp />user<sp />wants<sp />to<sp />setup<sp />theirs<sp />own</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />custom<sp />pipe.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />Instead,<sp />in<sp />general<sp />cases<sp />user<sp />can<sp />just<sp />register<sp />custom<sp />client<sp />IDs</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />(callbacks)<sp />into<sp />the<sp />System<sp />Pipe<sp />(CYPIPE)<sp />using<sp />Cy_IPC_Pipe_RegisterCallback</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__ipc__pipe__config__t">cy_stc_ipc_pipe_config_t</ref><sp />myIpcPipeConfig<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />myIpcPipeEp0Config,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />CM0+<sp />endpoint<sp />configuration<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />myIpcPipeEp1Config,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />CM4<sp /><sp />endpoint<sp />configuration<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />MY_IPC_PIPE_CLIENT_CNT,<sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.endpointClientsCount<sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />myIpcPipeCbArray,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.endpointsCallbacksArray<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />&amp;My_IPC_PipeIsr<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.userPipeIsrHandler<sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ipc__pipe__functions_1gafb7fa479327e6d7c282c262bc1dc6c8c">Cy_IPC_Pipe_Init</ref>(&amp;myIpcPipeConfig);</highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="139" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_pipe.c" bodystart="82" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_ipc_pipe.h" line="275" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__ipc__pipe__functions_1ga77c9655edfb8596d5d713f8ec54417c2" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__ipc__pipe__enums_1ga91750337b3471d3eb01ec316358d0598">cy_en_ipc_pipe_status_t</ref></type>
        <definition>cy_en_ipc_pipe_status_t Cy_IPC_Pipe_EndpointPause</definition>
        <argsstring>(uint32_t epAddr)</argsstring>
        <name>Cy_IPC_Pipe_EndpointPause</name>
        <param>
          <type>uint32_t</type>
          <declname>epAddr</declname>
        </param>
        <briefdescription>
<para>This function sets the receiver endpoint to paused state. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>epAddr</parametername>
</parameternamelist>
<parameterdescription>
<para>This parameter is the address (or index in the array of endpoint structures) that designates the endpoint to pause.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_IPC_PIPE_SUCCESS: Callback registered successfully</para></simplesect>
<simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />the<sp />CPU<sp />needs<sp />to<sp />perform<sp />some<sp />critical<sp />operation</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />that<sp />cannot<sp />be<sp />disturbed.<sp />So<sp />there<sp />is<sp />a<sp />need<sp />to<sp />put<sp />the<sp />endpoint<sp />into</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />paused<sp />state<sp />while<sp />the<sp />operation<sp />is<sp />being<sp />performed.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ipc__pipe__functions_1ga77c9655edfb8596d5d713f8ec54417c2">Cy_IPC_Pipe_EndpointPause</ref>(CY_IPC_EP_CYPIPE_ADDR);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Perform<sp />the<sp />critical<sp />operation<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Resume<sp />endpoint,<sp />return<sp />to<sp />normal<sp />pipe<sp />operation<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ipc__pipe__functions_1ga0b6560e9b7a9a156b79d1380e7003dab">Cy_IPC_Pipe_EndpointResume</ref>(CY_IPC_EP_CYPIPE_ADDR);</highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="573" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_pipe.c" bodystart="561" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_ipc_pipe.h" line="277" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__ipc__pipe__functions_1ga0b6560e9b7a9a156b79d1380e7003dab" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__ipc__pipe__enums_1ga91750337b3471d3eb01ec316358d0598">cy_en_ipc_pipe_status_t</ref></type>
        <definition>cy_en_ipc_pipe_status_t Cy_IPC_Pipe_EndpointResume</definition>
        <argsstring>(uint32_t epAddr)</argsstring>
        <name>Cy_IPC_Pipe_EndpointResume</name>
        <param>
          <type>uint32_t</type>
          <declname>epAddr</declname>
        </param>
        <briefdescription>
<para>This function sets the receiver endpoint to active state. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>epAddr</parametername>
</parameternamelist>
<parameterdescription>
<para>This parameter is the address (or index in the array of endpoint structures) that designates the endpoint to resume.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_IPC_PIPE_SUCCESS: Callback registered successfully</para></simplesect>
<simplesect kind="par"><title>Function Usage</title><para><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />the<sp />CPU<sp />needs<sp />to<sp />perform<sp />some<sp />critical<sp />operation</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />that<sp />cannot<sp />be<sp />disturbed.<sp />So<sp />there<sp />is<sp />a<sp />need<sp />to<sp />put<sp />the<sp />endpoint<sp />into</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />paused<sp />state<sp />while<sp />the<sp />operation<sp />is<sp />being<sp />performed.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ipc__pipe__functions_1ga77c9655edfb8596d5d713f8ec54417c2">Cy_IPC_Pipe_EndpointPause</ref>(CY_IPC_EP_CYPIPE_ADDR);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Perform<sp />the<sp />critical<sp />operation<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Resume<sp />endpoint,<sp />return<sp />to<sp />normal<sp />pipe<sp />operation<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ipc__pipe__functions_1ga0b6560e9b7a9a156b79d1380e7003dab">Cy_IPC_Pipe_EndpointResume</ref>(CY_IPC_EP_CYPIPE_ADDR);</highlight></codeline>
</programlisting></para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="605" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_pipe.c" bodystart="593" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_ipc_pipe.h" line="278" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__ipc__pipe__functions_1ga57550447f7bca5f2990868bac69f41dc" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void Cy_IPC_Pipe_ExecCallback</definition>
        <argsstring>(cy_stc_ipc_pipe_ep_t *endpoint)</argsstring>
        <name>Cy_IPC_Pipe_ExecCallback</name>
        <param>
          <type><ref kindref="compound" refid="structcy__stc__ipc__pipe__ep__t">cy_stc_ipc_pipe_ep_t</ref> *</type>
          <declname>endpoint</declname>
        </param>
        <briefdescription>
<para>This function is called by the ISR for a given pipe endpoint to dispatch the appropriate callback function based on the client ID for that endpoint. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>endpoint</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to endpoint structure.</para></parameterdescription>
</parameteritem>
</parameterlist>
<verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;This function is obsolete and will be removed in the next releases. Please use &lt;a href="group__group__ipc__pipe__functions.html#group__group__ipc__pipe__functions_1ga7cff3c4286e6e23519d9925d394ac218"&gt;Cy_IPC_Pipe_ExecuteCallback()&lt;/a&gt; instead. &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="541" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_ipc_pipe.c" bodystart="465" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/include/cy_ipc_pipe.h" line="281" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>Functions are used in the driver. </para>    </briefdescription>
    <detaileddescription>
    </detaileddescription>
  </compounddef>
</doxygen>